/* mdump.c */

static char rcsid[] = "$Id: mdump.c,v 1.3 1994/07/31 10:38:58 JACK Exp $";

#include	<stdio.h>
#include	<stdlib.h>
#include	<unistd.h>
#include	<string.h>
#include	<mbctype.h>
#include	<mbstring.h>
#include	<limits.h>
#include	<sys/dos.h>
#include	<sys/iocs.h>

#include	"mdump.h"
#include	"twin.h"
#include	"eucctype.h"

#ifndef FONTSIZE
#define FONTSIZE 16
#elif ((FONTSIZE != 12) && (FONTSIZE != 16) && (FONTSIZE != 24))
#error
#endif

/* Tu[` */
extern int mdump_jump(struct fileinfo *);
extern void mdump_help(void);

/* obt@o̓Tu[` */
extern int hexput(char *, register int, int);
extern int mdump_line_sjisput(char *, struct fileinfo *, int, int, char);
extern int mdump_line_eucput(char *, struct fileinfo *, int, int, char);

/* Wo͗p̃Tu[`錾 */
extern int mdump_stdout(char *file);

/* IOCS x̃L[̓Tu[`̐錾 */
extern int key_in(void);
extern void key_flush(void);
extern int key_wait(void);


/* t@Cfileinfoobt@pӂ */
struct fileinfo *make_fileinfo(char *file)
{
	struct fileinfo *finfo;
	char drv[3];
	char path[MAX_PATH_LEN];
	char node[MAX_PATH_LEN];
	char ext[MAX_PATH_LEN];
	int maxsize;
	int len;

	finfo = xmalloc(sizeof(struct fileinfo));

	strsfn(file, drv, path, node, ext);
	strncpy(finfo->name, node, 22-1);
	finfo->name[22] = '\0';
	len = strlen(finfo->name);
	if(ext[0] != '\0' && len++ < 22) {
		strcat(finfo->name, ".");
		strncat(finfo->name, ext, 22-len);
	}

	finfo->offset = OFFSET;
	finfo->readsize = 0;
	finfo->readend = 0;
	if ((finfo->fp = fopen(file, "rb")) == NULL) {
		finfo->access = -1;
	} else {
		finfo->access = 0;
		finfo->size = filelength(fileno(finfo->fp));
		if (opt_a) {
			if (MAXREADSIZE != 0) {
				/* 𒴂Ȃ悤Ɋmۂ */
				finfo->readbuf = malloc(min(MAXREADSIZE,finfo->size));
			} else {
				/* t@CTCYm */
				finfo->readbuf = malloc(finfo->size);
			}
			/* Œ 128KB͎c */
			if (finfo->readbuf != NULL && chkml() < 0x20000) {
				free(finfo->readbuf);
				finfo->readbuf = NULL;
			}
			/* mۂłȂꍇ͊mۂł邾 */
			if (finfo->readbuf == NULL) {
				/* 󃁃𒲂ׂ */
				maxsize = chkml();
				/* 16oCgPʂɋl߂ */
				maxsize &= 0xfffffff0;
				/* Œ 128KB͎c */
				maxsize -= 0x20000;
				while (1) {
					if (maxsize <= 0) {
						/* SɊmۂłȂ */
						printf("SɊmۂł܂\n");
						exit(1);
					}
					finfo->readbuf = malloc(maxsize);
					if (finfo->readbuf != NULL) {
						/* mۂł */
						break;
					}
					/* TCYk߂đ */
					maxsize -= 0x1000;
				}
				MAXREADSIZE = maxsize;
			}
		} else {
			/* mێw肪Ȃꍇ */
			if (MAXREADSIZE != 0) {
				/* 𒴂Ȃ悤Ɋmۂ */
				finfo->readbuf = xmalloc(min(MAXREADSIZE,finfo->size));
			} else {
				/* t@CTCYm */
				finfo->readbuf = xmalloc(finfo->size);
			}
			/* Œ 128KB͎c */
			if (chkml() < 0x20000) {
				printf("sĂ܂. -a Ă.\n");
				exit(1);
			}
		}
		if (OFFSET != 0) {
			if (finfo->size > OFFSET) {
				fseek(finfo->fp, OFFSET, SEEK_SET);
				finfo->readsize = OFFSET;
			}
		}
	}

	return finfo;
}

/* wTCY𒴂Ȃ悤ɓǂݍ */
int read_file(struct fileinfo *finfo, int maxsize)
{
	int size;
	unsigned char *buffer;

	if (MAXREADSIZE == 0) {
		size = finfo->size - finfo->readsize;
		if (size <= 0) {
			/* ɓǂݏIĂ */
			finfo->readend = 1;
			return 1;
		}
	} else {
		if (OFFSET+MAXREADSIZE < finfo->size) {
			size = OFFSET + MAXREADSIZE - finfo->readsize;
			if (size <= 0) {
				/* ɓǂݏIĂ */
				finfo->readend = 1;
				return 2;
			}
		} else {
			size = finfo->size - finfo->readsize;
			if (size <= 0) {
				/* ɓǂݏIĂ */
				finfo->readend = 1;
				return 2;
			}
		}
	}

	if (size > maxsize)
		size = maxsize;

	buffer = finfo->readbuf + (finfo->readsize - OFFSET);
	fread(buffer, size, 1, finfo->fp);
	finfo->readsize += size;
	return 0;
}

void print_info(TWIN* win, short tcol, struct fileinfo *finfo)
{
	static char *mes_code[] = {"AUTO", "SJIS", "EUC "};
	char buf[128];

	if (win->tdraw == 0) {
		twindraw(win, WIN_MINT, "t@C", tcol);
	} else {
		twinredraw(win, win->ttype, NULL, win->ttcol);
	}
	twincolor(win, 3);

	sprintf(buf, "<%s>", finfo->name);
	twinlocate(win, 0, 0);
	twinprint(win, buf);

	sprintf(buf, "size  :%9d", finfo->size);
	twinlocate(win, 0, 1);
	twinprint(win, buf);

	sprintf(buf, "read  :%9d", finfo->readsize);
	twinlocate(win, 0, 2);
	twinprint(win, buf);

	sprintf(buf, "offset:$%8.8x", OFFSET);
	twinlocate(win, 0, 3);
	twinprint(win, buf);

	twinlocate(win, 18, 1);
	twinprint(win, "code");
	twinlocate(win, 18, 2);
	twinprint(win, mes_code[CODE]);
}

void print_error(char *str)
{
	TWIN *win;
	short x, y, wx, wy = 1;
	short col = 1, fsize = FONTSIZE;
	short type = WIN_MINT;
	short pcol = 3;
	short tcol = col+0x08;
	struct _fntbuf curfnt;

	/* J[\p^[ */
	_iocs_fntget(fsize/2, L'', &curfnt);

	/* ̒ɃEBhETCY */
	wx = strlen(str)+3;

	/* tHgTCYlăZ^O */
	x = (768/(fsize/2)/2) - ((wx+2)/2);
	y = ((16*24)/fsize/2) - ((wy+2)/2);

	/* EBhE|C^mۂ */
	win = twinopen(x, y, wx, wy, col, fsize);
	win->tbufp = xmalloc(twinworksize(win));

	/* J[\p^[̐ݒ */
	win->tcurpat = &curfnt;

	/* EBhE\ */
	twindraw(win, type, "mdump: G[", tcol);

	/* bZ[W\Fݒ */
	twincolor(win, pcol);

	/* G[v\ */
	twinlocate(win, 0, 0);
	twinprint(win, str);
	twinputc(win, ' ');

	/* J[\\(_) */
	twincuron(win);
	/* L[͑҂ */
	key_wait();
	/* J[\ */
	twincuroff(win);

	twinclear(win);
	xfree(win->tbufp);
	twinclose(win);
}

void error_no_file(struct fileinfo *finfo)
{
	char buf[128];

	sprintf(buf, "%s ܂.", finfo->name);
	print_error(buf);
}

void error_offset(struct fileinfo *finfo)
{
	print_error("ItZbgw肪傫܂.");
}

#define	CHECKSIZE	8

/* obt@ɘA{ăR[h߂ */
int code_check(unsigned char *p, int maxsize)
{
	int euc_error = 0;
	int sjis_error = 0;
	int i = 0;
	int euc_knj = 0;
	int sjis_knj = 0;
	unsigned short c, cc;
	unsigned char *pp;

	while (i + CHECKSIZE*2 <= maxsize) {
		c = p[0];

		if (euc_knj) {
			euc_knj = 0;
		} else {
			if (c == 0x8e) {
				euc_knj = 1;
				cc = p[1];
				if (cc < 0xa1 || cc > 0xdf) {
					euc_error++;
				}
			} else if (iseucfirst(c)) {
				euc_knj = 1;
				pp = p+2;
				cc = c << 8;
				cc += p[1];
				if (! iseuc(cc)) {
					euc_error++;
				}
				while (iseuc(cc) && iseucfirst(*pp)) {
					if (pp >= p + CHECKSIZE*2) {
						/* EUC[h */
						return 2;
					}
					cc = *pp++ << 8;
					cc += *pp++;
				}
			}
		}

		if (sjis_knj) {
			sjis_knj = 0;
		} else {
			if (ismbblead(c)) {
				sjis_knj = 1;
				pp = p+2;
				cc = c << 8;
				cc += p[1];
				if (! ismbclegal(cc)) {
					sjis_error++;
				}
				while (ismbclegal(cc) && ismbblead(*pp)) {
					if (pp >= p + CHECKSIZE*2) {
						/* SJIS[h */
						return 1;
					}
					cc = *pp++ << 8;
					cc += *pp++;
				}
			}
		}

		p++;
		i++;
	}	/* for while */

	/* 킩ȂG[̏Ȃ */
	return euc_error >= sjis_error ? 1 : 2;
}

/* wʒu(0`15)ɕ\ */
int mdump_line(TWIN *win, struct fileinfo *finfo, int mode, int pos)
{
	char buf[128];
	char *pp;
	int i, ret;

	switch (CODE) {
		case 2:
			/* EUC */
			ret = mdump_line_eucput(buf, finfo, mode, pos, '|');
			break;
		case 1:
		default:
			/* SJIS */
			ret = mdump_line_sjisput(buf, finfo, mode, pos, '|');
			break;
	}

	/* Ps܂Ƃ߂ĕ\ */
	twinlocate(win, 0, pos);
	twinprint(win, buf);

	i = win->txmax - win->tcurx;
	i++;
	/* E[̑Sp(S~) */
	if (i > 0) {
		pp = buf;
		while (i--) {
			*pp++ = ' ';
		}
		*pp++ = '\0';
		twinprint(win, buf);
	}
	return ret;
}

/* Sʏ */
void mdump_all(TWIN *win, struct fileinfo *finfo, int mode)
{
	int i;

	for (i = 0; i < 16; i++) {
		if (mdump_line(win, finfo, mode, i) != 0) {
			if (i < 15) {
				/* ]NA */
				twinlocate(win, 0, i+1);
				twinprint(win, "\x1b[0J");
			}
			break;
		}
	}
}

int page_up(TWIN *win, struct fileinfo *finfo, int mode)
{
	int next;

	next = finfo->offset + 0x100;
	if (next+0xf0 >= finfo->readsize) {
		if (finfo->readend == 0) {
			/* ܂t@CǂݏIĂȂ */
			return 1;
		} else {
			if (finfo->offset == OFFSET && next >= finfo->readsize) {
				/* 悪Ȃ */
				return 0;
			} else {
				/* ANZX\ȂƂ܂ */
				next = finfo->readsize;
				next += 15;
				next &= 0xfffffff0;
				next -= 0x100;
			}
		}
	}
	if (next == finfo->offset) {
		/* ItZbglȂ\Kv͂Ȃ */
		return 0;
	}

	finfo->offset = next;
	mdump_all(win, finfo, mode);
	return 0;
}

int page_down(TWIN *win, struct fileinfo *finfo, int mode)
{
	int next;

	next = finfo->offset - 0x100;
	if (next < OFFSET) {
		if (finfo->offset == OFFSET) {
			if (finfo->readend == 0) {
				/* ܂t@CǂݏIĂȂ */
				return 1;
			} else {
				/* ȏt@C͓ǂ߂Ȃ̂Œf */
				return 0;
			}
		} else {
			/* y[WAbvłȂ擪܂ */
			next = OFFSET;
		}
	}
	if (next == finfo->offset) {
		/* ItZbglȂ\Kv͂Ȃ */
		return 0;
	}

	finfo->offset = next;
	mdump_all(win, finfo, mode);
	return 0;
}

int page_top(TWIN *win, struct fileinfo *finfo, int mode)
{
	int next;

	next = OFFSET;
	if (next == finfo->offset) {
		/* ItZbglȂ\Kv͂Ȃ */
		return 0;
	}

	finfo->offset = next;
	mdump_all(win, finfo, mode);
	return 0;
}

int page_end(TWIN *win, struct fileinfo *finfo, int mode)
{
	int next;

	next = finfo->readsize;
	next += 15;
	next &= 0xfffffff0;
	next -= 0x100;
	if (next < OFFSET) {
		next = OFFSET;
	}
	if (next == finfo->offset) {
		/* ItZbglȂ\Kv͂Ȃ */
		return 0;
	}

	finfo->offset = next;
	mdump_all(win, finfo, mode);
	return 0;
}

int roll_up(TWIN *win, struct fileinfo *finfo, int mode)
{
	int next;

	next = finfo->offset + 0x10;
	if (next+0xf0 >= finfo->readsize) {
		if (finfo->readend == 0) {
			/* ܂t@CǂݏIĂȂ */
			return 1;
		} else {
			/* ȏt@C͓ǂ߂Ȃ̂Œf */
			return 0;
		}
	}
	if (next == finfo->offset) {
		/* ItZbglȂ\Kv͂Ȃ */
		return 0;
	}

	twinlocate(win, 0, 15);
	/* GXP[vV[PXłPsXN[Abv */
	twinprint(win, "\x1b""D");

	finfo->offset = next;
	mdump_line(win, finfo, mode, 15);
	return 0;
}

int roll_down(TWIN *win, struct fileinfo *finfo, int mode)
{
	int next;

	next = finfo->offset - 0x10;
	if (next < OFFSET) {
		if (finfo->readend == 0) {
			/* ܂t@CǂݏIĂȂ */
			return 1;
		} else {
			/* ȏt@C͓ǂ߂Ȃ̂Œf */
			return 0;
		}
	}
	if (next == finfo->offset) {
		/* ItZbglȂ\Kv͂Ȃ */
		return 0;
	}

	twinlocate(win, 0, 0);
	/* GXP[vV[PXłPsXN[_E */
	twinprint(win, "\x1b""M");

	finfo->offset = next;
	mdump_line(win, finfo, mode, 0);

	return 0;
}

#define	KEY_NULL	0x0000
#define	KEY_RUP		0x0001
#define	KEY_RDOWN	0x0002
#define	KEY_CRUP	0x0101
#define	KEY_CRDOWN	0x0102
#define	KEY_UP		0x0004
#define	KEY_DOWN	0x0008
#define	KEY_LEFT	0x0010
#define	KEY_RIGHT	0x0011
#define	KEY_ESC		0x0020
#define	KEY_MODE	0x0021
#define	KEY_CODE	0x0022
#define	KEY_JUMP	0x0023
#define	KEY_HELP	0x0040

int mdump_key_in(void)
{
	int c, s;

	c = key_in();
	s = _iocs_b_sftsns();

	switch (c) {
	case 0x011b:
		/* ESC */
	case 0x3a00:
		/* UNDO */
		return KEY_ESC;
	case 0x3800:
		/* ROLL UP */
		if (s & 0x02)	return KEY_CRUP;
		return KEY_RUP;
	case 0x3900:
		/* ROLL DOWN */
		if (s & 0x02)	return KEY_CRDOWN;
		return KEY_RDOWN;
	case 0x3b00:
		/*  */
		return KEY_LEFT;
	case 0x3c00:
		/*  */
		return KEY_UP;
	case 0x3d00:
		/* E */
		return KEY_RIGHT;
	case 0x3e00:
		/*  */
		return KEY_DOWN;
	case 0x304d:
	case 0x306d:
		/* m/M */
		return KEY_MODE;
	case 0x2c43:
	case 0x2c63:
		/* c/C */
		return KEY_CODE;
	case 0x244a:
	case 0x246a:
		/* j/J */
		return KEY_JUMP;
	case 0x5400:
		/* HELP */
		return KEY_HELP;
	case 0:
		/* ͂Ȃ */
	default:
		return KEY_NULL;
	}
	return KEY_NULL;
}

/* mode = 0:oCg\ 1:[h\ */
void mdump_header(TWIN *win, int mode)
{
	/* tXN[ */
	twinconsol(win, 0, 0, win->twx-1, win->twy-1);

	/* wb_̕\ */
	twinlocate(win, 0, 0);
	twinprint(win, " offset | ");
	switch (mode) {
	case 1:
		twinprint(win, " +0   +2   +4   +6   +8   +a   +c   +e  ");
		break;
	case 0:
	default:
		twinprint(win, "+0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +a +b +c +d +e +f ");
		break;
	}
	twinprint(win, " 0123456789abcdef");

	/* XN[͈͂ݒ肷 */
	twinconsol(win, 0, 1, win->twx-1, win->twy-2);
}


int mdump(char *file)
{
	/* CEBhEp */
	TWIN *win;
	short x = 4, y = 8, wx = 76, wy = 16+1;
	short col = 1, fsize = FONTSIZE;
	short tcol = col+0x08;
	static char main_title[] = "_vEEBhE";
	static short mwx[] = { 76, 68 };

	/* fileinfop */
	TWIN *win2;
	short x2 = 16, y2 = 2, wx2 = 23+1, wy2 = 4;

	int c;
	int mode;
	int buffer_size;
	struct fileinfo *finfo;

	/* -d w肳Ă stdout ɏo͂ */
	if (opt_d) {
		return mdump_stdout(file);
	}

	/* \[h𓾂 */
	mode = MODE;

	/* t@CI[vēǂݍ݃obt@mۂ */
	finfo = make_fileinfo(file);

	/* ftHg̓EBhE\ */
	if (finfo->access) {
		error_no_file(finfo);
		return -1;
	}
	if (finfo->size <= OFFSET) {
		error_offset(finfo);
		return -2;
	}

	/* [hɂĉ𒲐 */
	wx = mwx[mode];

	/* CEBhEI[v */
	win = twinopen(x, y, wx, wy, col, fsize);

	/* obt@͍őTCYɂ킹Ċmۂ */
	/* XTCYoCgPʂɐ؂グāAYTCYāAwb_4oCĝ
	   v[0/1̓pӂ */
	/* EBhEŒTCYȂ twinworksize() gΊȒPɋ܂܂ */
	buffer_size = ((((76+2)*(fsize/2)+7)/8)*((wy+2)*fsize)+4)*2;
	win->tbufp = xmalloc(buffer_size);

	/* EBhE\܂ */
	twindraw(win, WIN_MINT, main_title, tcol);
	twincolor(win, 3);

	/* t@CEBhE̕\ */
	win2 = twinopen(x2, y2, wx2, wy2, col, fsize);
	win2->tbufp = xmalloc(twinworksize(win2));
	print_info(win2, tcol, finfo);

	/* wb_\ăXN[͈͂ݒ肷 */
	mdump_header(win, mode);

	if (opt_r) {
		/* L[̓obt@NA */
		key_flush();

		/* -r ňCɑSǂ */
		while(read_file(finfo, 8192) == 0) {
			print_info(win2, tcol, finfo);

			/* ESCL[Œf */
			c = mdump_key_in();
			switch (c) {
				case KEY_ESC:
					/* ESC */
					goto loop_exit;
			}
		}
	} else {
		/* t@C8KBǂݍ */
		read_file(finfo, 8192);
		print_info(win2, tcol, finfo);
	}

	/* AUTO[hȂR[h߂ */
	if (CODE == 0) {
		CODE = code_check(finfo->readbuf, min(finfo->readsize,8192));
		print_info(win2, tcol, finfo);
	}

	/* Ƃ肠Sʕ\ */
	mdump_all(win, finfo, mode);

	/* L[̓obt@NA */
	key_flush();

	/* C[v */
	while (1) {
		c = mdump_key_in();
		switch (c) {
		case KEY_ESC:
			/* ESC */
			goto loop_exit;

		case KEY_CRUP:
			/* CTRL + ROLL UP */
			key_flush();
			c = page_end(win, finfo, mode);
			break;
		case KEY_CRDOWN:
			/* CTRL + ROLL DOWN */
			key_flush();
			c = page_top(win, finfo, mode);
			break;

		case KEY_RUP:
			/* ROLL UP */
			key_flush();
			c = page_up(win, finfo, mode);
			break;
		case KEY_RDOWN:
			/* ROLL DOWN */
			key_flush();
			c = page_down(win, finfo, mode);
			break;

		case KEY_LEFT:
			/*  */
			key_flush();
			twinprint(win, "\x1b[?4h");
			c = roll_down(win, finfo, mode);
			twinprint(win, "\x1b[?4l");
			break;

		case KEY_UP:
			/*  */
			key_flush();
			c = roll_down(win, finfo, mode);
			break;

		case KEY_RIGHT:
			/* E */
			key_flush();
			twinprint(win, "\x1b[?4h");
			c = roll_up(win, finfo, mode);
			twinprint(win, "\x1b[?4l");
			break;

		case KEY_DOWN:
			/*  */
			key_flush();
			c = roll_up(win, finfo, mode);
			break;

		case KEY_MODE:
			/* M */
			/* \[h̕ύX */

			/* ܂݂̃EBhE */
			twinclear(win);

			/* \[h̓gO */
			mode ^= 1;

			/* [hɂĉ𒲐 */
			wx = mwx[mode];

			/* CEBhẼTCY */
			twinresize(win, x, y, wx, wy, col, fsize);

			/* ĕ\ */
			twindraw(win, WIN_MINT, main_title, tcol);
			twincolor(win, 3);

			/* wb_\ăXN[͈͂ݒ肷 */
			mdump_header(win, mode);

			/* Sʕ\ */
			key_flush();
			mdump_all(win, finfo, mode);

			/* t@C͓ǂ܂Ȃ */
			c = 0;
			break;

		case KEY_CODE:
			/* C */
			/* \R[h̕ύX */

			/* ܂݂̕\ */
			twincls(win);

			/* \R[h̓gO */
			CODE ^= 3;

			/* Sʕ\ */
			key_flush();
			mdump_all(win, finfo, mode);
			print_info(win2, tcol, finfo);

			/* t@C͓ǂ܂Ȃ */
			c = 0;
			break;

		case KEY_JUMP:
			/* J */
			/* wAhXɃWv */
			key_flush();
			c = finfo->offset;
			if (mdump_jump(finfo) != c) {
				/* Sʕ\ */
				key_flush();
				mdump_all(win, finfo, mode);
			}

			/* t@C͓ǂ܂Ȃ */
			c = 0;
			break;

		case KEY_HELP:
			/* HELP */
			/* wvt@C̕\ */
			key_flush();
			mdump_help();

			/* Sʕ\ */
			key_flush();
			mdump_all(win, finfo, mode);

			/* t@C͓ǂ܂Ȃ */
			c = 0;
			break;

		case KEY_NULL:
		default:
			/* ͂Ȃ */
			c = 1;
			break;
		}

		if (c && finfo->readend == 0) {
			/* L[͂Ȃ1KBǂݍ */
			if (read_file(finfo, 1024) == 0) {
				print_info(win2, tcol, finfo);
			}
		}
	}

/* ESC L[ */
loop_exit:
	/* L[̓obt@NA */
	key_flush();

	/* mۂ fileinfo ̂Ă */
	fclose(finfo->fp);
	xfree(finfo->readbuf);
	xfree(finfo);

	/* EBhE */
	twinclear(win2);
	xfree(win2->tbufp);
	twinclose(win2);

	twinclear(win);
	xfree(win->tbufp);
	twinclose(win);

	/* I */
	return 0;
}
