/* mdump_stdout.c */

static char rcsid[] = "$Id: mdump_stdout.c,v 1.1 1994/07/30 05:49:23 JACK Exp $";

#include	<stdio.h>
#include	<stdlib.h>

#include	"mdump.h"


/* gpTu[`̐錾 */
extern int hexput(char *, register int, int);
extern int mdump_line_sjisput(char *, struct fileinfo *, int, int, char);
extern int mdump_line_eucput(char *, struct fileinfo *, int, int, char);

extern struct fileinfo *make_fileinfo(char *);
extern int read_file(struct fileinfo *, int);
extern int code_check(unsigned char *, int);
extern int mdump_key_in(void);

extern int key_in(void);
extern void key_flush(void);
extern int key_wait(void);


#define	KEY_NUL		0x0000
#define	KEY_RUP		0x0001
#define	KEY_RDOWN	0x0002
#define	KEY_CRUP	0x0101
#define	KEY_CRDOWN	0x0102
#define	KEY_UP		0x0004
#define	KEY_DOWN	0x0008
#define	KEY_LEFT	0x0010
#define	KEY_RIGHT	0x0011
#define	KEY_ESC		0x0020
#define	KEY_MODE	0x0021
#define	KEY_CODE	0x0022


void error_no_file_stdout(struct fileinfo *finfo)
{
	fprintf(stdout, "%s ܂\n", finfo->name);
}

void error_offset_stdout(struct fileinfo *finfo)
{
	fprintf(stdout, "ItZbgw肪傫܂.\n");
}

int mdump_stdout_line(struct fileinfo *finfo, int mode)
{
	char buf[128];
	int ret;

	switch (CODE) {
		case 2:
			/* EUC */
			ret = mdump_line_eucput(buf, finfo, mode, 0, ' ');
			break;
		case 1:
		default:
			/* SJIS */
			ret = mdump_line_sjisput(buf, finfo, mode, 0, ' ');
			break;
	}

	/* Wo͂ɕ\ */
	fputs(buf, stdout);
	/* s */
	fputc('\n', stdout);

	return ret;
}

int mdump_stdout(char *file)
{
	int c;
	int mode;
	struct fileinfo *finfo;

	/* \[h𓾂 */
	mode = MODE;

	/* t@CI[vēǂݍ݃obt@mۂ */
	finfo = make_fileinfo(file);

	if (finfo->access) {
		error_no_file_stdout(finfo);
		return -1;
	}
	if (finfo->size <= OFFSET) {
		error_offset_stdout(finfo);
		return -2;
	}

	/* L[̓obt@NA */
	key_flush();

	/* t@C͍ŏɑSǂݍ */
	while(read_file(finfo, 8192) == 0) {
		/* ESCL[Œf */
		c = mdump_key_in();
		switch (c) {
			case KEY_ESC:
				/* ESC */
				goto loop_exit;
		}
	}

		;
	/* AUTO[hȂR[h߂ */
	if (CODE == 0) {
		CODE = code_check(finfo->readbuf, min(finfo->readsize,8192));
	}
	/* stdout ɂPsÂo͂ */
	while(mdump_stdout_line(finfo, mode) == 0) {
		finfo->offset += 0x10;
	}

/* ESC L[ */
loop_exit:
	/* mۂ fileinfo ̂Ă */
	fclose(finfo->fp);
	xfree(finfo->readbuf);
	xfree(finfo);

	/* I */
	return 0;
}
